module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 3);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("inversify");

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(4));


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Palette_1 = __webpack_require__(5);
exports.Palette = Palette_1.default;
var InputPanel_1 = __webpack_require__(7);
exports.InputPanel = InputPanel_1.default;
var MonacoLoader_1 = __webpack_require__(8);
exports.MonacoLoader = MonacoLoader_1.default;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_monaco_editor_1 = __webpack_require__(6);
class Palette extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            code: '// type your code...',
        };
    }
    editorDidMount(editor, monaco) {
        editor.addAction({
            id: 'my-unique-id',
            label: 'Git: Clone',
            keybindings: [monaco.KeyMod.CtrlCmd | monaco.KeyCode.F10],
            contextMenuGroupId: 'git',
            contextMenuOrder: 1,
            run: function (ed) {
                console.log("i'm running => " + ed.getPosition());
            },
        });
    }
    render() {
        const code = this.state.code;
        const requireConfig = {
            url: 'https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.1/require.min.js',
            paths: {
                vs: 'https://as.alipayobjects.com/g/cicada/monaco-editor-mirror/0.6.1/min/vs',
            },
        };
        return (React.createElement(react_monaco_editor_1.default, { width: "800", height: "600", language: "javascript", value: code, requireConfig: requireConfig, editorDidMount: this.editorDidMount }));
    }
}
exports.default = Palette;


/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("react-monaco-editor");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(1);
class InputPanel extends React.Component {
    constructor(props) {
        super(props);
        this.handlerKeyPress = e => {
            if (e.key === 'Enter') {
                this.props.hideInputModal();
                this.props.setInputValue(this.state.value);
                this.setState({ value: '' });
            }
            else if (e.key === 'Escape') {
                this.props.hideInputModal();
            }
        };
        this.handlerChange = e => this.setState({ value: e.target.value });
        this.state = {
            value: '',
        };
    }
    render() {
        const { styles, modalInput } = this.props;
        const { value } = this.state;
        if (!modalInput) {
            return null;
        }
        const { inputType, description, placeholder } = modalInput;
        return (React.createElement("div", { className: styles.container, onKeyDown: this.handlerKeyPress },
            React.createElement("input", { className: styles.input, type: inputType || 'text', placeholder: placeholder, value: value, onChange: this.handlerChange }),
            React.createElement("div", { className: styles.description }, description)));
    }
}
exports.default = react_fela_1.connect({
    container: () => ({
        position: 'fixed',
        width: '300px',
        backgroundColor: 'rgb(38, 38, 38)',
        top: '0',
        marginLeft: 'auto',
        marginRight: 'auto',
        left: '0',
        right: '0',
        padding: '10px',
        zIndex: '1',
    }),
    description: () => ({
        background: '#041F37',
        color: '#fff',
        margin: '5px 0 0',
        padding: '10px',
    }),
    input: () => ({
        width: '100%',
        padding: '10px',
        color: '#8a8a8a',
    }),
})(InputPanel);


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const trashable_react_1 = __webpack_require__(9);
const react_fela_1 = __webpack_require__(1);
const monacoLoader_1 = __webpack_require__(10);
const react_content_loader_1 = __webpack_require__(11);
var StatusTypes;
(function (StatusTypes) {
    StatusTypes["none"] = "none";
    StatusTypes["pending"] = "pending";
    StatusTypes["rejected"] = "rejected";
    StatusTypes["resolved"] = "resolved";
})(StatusTypes = exports.StatusTypes || (exports.StatusTypes = {}));
class MonacoLoader extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            status: StatusTypes.none,
        };
    }
    componentWillMount() {
        if (typeof window['require'] === 'undefined') {
            this.props.registerPromise(monacoLoader_1.loadVsRequire(window))
                .then(vsREquire => {
                this.setState({
                    status: StatusTypes.resolved,
                });
            })
                .catch((err) => {
                this.setState({
                    status: StatusTypes.rejected,
                });
                console.error('loading of monaco was failed');
            });
        }
        else {
            this.setState({
                status: StatusTypes.resolved,
            });
        }
    }
    render() {
        const { state, props } = this;
        const { styles, diff } = props;
        switch (state.status) {
            case StatusTypes.none:
                return React.createElement("div", { className: styles.loader },
                    React.createElement(react_content_loader_1.Code, { width: 1000 }));
            case StatusTypes.pending:
                return React.createElement("div", { className: styles.loader },
                    React.createElement(react_content_loader_1.Code, { width: 1000 }));
            case StatusTypes.resolved:
                {
                    if (diff) {
                        const { default: MonacoDiffEditor } = __webpack_require__(12);
                        return React.createElement(MonacoDiffEditor, Object.assign({}, props, { context: window }));
                    }
                    const { default: MonacoEditor } = __webpack_require__(13);
                    return React.createElement(MonacoEditor, Object.assign({}, props, { context: window }));
                }
            case StatusTypes.rejected:
                return React.createElement("div", null, " rejected");
        }
        return null;
    }
}
exports.default = react_fela_1.connect({
    loader: () => ({
        padding: '10px',
    }),
})(trashable_react_1.default(MonacoLoader));


/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("trashable-react");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/monaco/lib/monacoLoader");

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("react-content-loader");

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const inversify_1 = __webpack_require__(2);
function noop() { }
const container = new inversify_1.Container();
let MonacoDiffEditor = class MonacoDiffEditor extends React.Component {
    constructor(props) {
        super(props);
        this.afterViewInit = () => {
            const context = this.props.context || window;
            if (context.monaco !== undefined) {
                this.initMonaco();
                return;
            }
        };
        this.assignRef = (component) => {
            this.containerElement = component;
        };
        this.containerElement = undefined;
        this.__current_value = props.value;
        this.__current_original = props.original;
    }
    componentDidMount() {
        this.afterViewInit();
    }
    componentDidUpdate(prevProps) {
        const context = this.props.context || window;
        if (this.props.value !== this.__current_value ||
            this.props.original !== this.__current_original) {
            this.__current_value = this.props.value;
            this.__current_original = this.props.original;
            if (this.editor) {
                this.__prevent_trigger_change_event = true;
                this.updateModel(this.__current_value, this.__current_original);
                this.__prevent_trigger_change_event = false;
            }
        }
        if (prevProps.language !== this.props.language) {
            context.monaco.editor.setModelLanguage(this.editor.modifiedEditor.getModel(), this.props.language);
        }
        if (prevProps.theme !== this.props.theme) {
            context.monaco.editor.setTheme(this.props.theme);
        }
        if ((this.props.width !== prevProps.width) || (this.props.height !== prevProps.height)) {
            this.editor.layout();
        }
    }
    componentWillUnmount() {
        this.destroyMonaco();
    }
    editorWillMount(monaco) {
        const { editorWillMount } = this.props;
        if (editorWillMount) {
            editorWillMount(monaco);
        }
    }
    editorDidMount(editor, monaco) {
        if (this.props.editorDidMount) {
            this.props.editorDidMount(editor, monaco);
        }
        editor.onDidUpdateDiff((event) => {
            const value = editor.getValue();
            if (!this.__prevent_trigger_change_event && value !== this.__current_value) {
                this.props.onChange(value, event);
            }
            this.__current_value = value;
        });
    }
    create(options, override) {
        const context = this.props.context || window;
        return this.editor = context.monaco.editor.createDiffEditor(this.containerElement, Object.assign({}, options, { fixedOverflowWidgets: true, scrollbar: {
                useShadows: false,
                verticalHasArrows: false,
                horizontalHasArrows: false,
                verticalScrollbarSize: 10,
                horizontalScrollbarSize: 10,
            } }), override);
    }
    updateModel(value, original) {
        const context = this.props.context || window;
        const { language } = this.props;
        const originalModel = context.monaco.editor.createModel(original, language);
        const modifiedModel = context.monaco.editor.createModel(value, language);
        this.editor.setModel({
            original: originalModel,
            modified: modifiedModel,
        });
    }
    initMonaco() {
        const value = this.props.value !== null ? this.props.value : this.props.defaultValue;
        const { original, language, theme, options } = this.props;
        const context = this.props.context || window;
        if (this.containerElement && typeof context.monaco !== 'undefined') {
            this.editorWillMount(context.monaco);
            this.editor = this.create(Object.assign({ value,
                language }, options));
            if (theme) {
                context.monaco.editor.setTheme(theme);
            }
            this.updateModel(value, original);
            this.editorDidMount(this.editor, context.monaco);
        }
    }
    destroyMonaco() {
        if (typeof this.editor !== 'undefined') {
            this.editor.dispose();
        }
    }
    render() {
        const { width, height } = this.props;
        const fixedWidth = width.toString().indexOf('%') !== -1 ? width : `${width}px`;
        const fixedHeight = height.toString().indexOf('%') !== -1 ? height : `${height}px`;
        const style = {
            width: fixedWidth,
            height: fixedHeight,
        };
        return (React.createElement("div", { ref: this.assignRef, style: style, className: "react-monaco-editor-container" }));
    }
};
MonacoDiffEditor.defaultProps = {
    width: '100%',
    height: '100%',
};
MonacoDiffEditor = __decorate([
    inversify_1.injectable()
], MonacoDiffEditor);
exports.default = MonacoDiffEditor;


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_apollo_1 = __webpack_require__(14);
const client_language_monaco_1 = __webpack_require__(15);
const MonacoEditor_1 = __webpack_require__(16);
exports.default = react_apollo_1.compose(react_apollo_1.graphql(client_language_monaco_1.OPEN_DOCUMENT_MUTATION, { name: 'openDocumentMutate' }), react_apollo_1.graphql(client_language_monaco_1.CHANGE_DOCUMENT_MUTATION, { name: 'changeDocumentMutate' }), react_apollo_1.graphql(client_language_monaco_1.HOVER_MUTATION, { name: 'hoverMutate' }), react_apollo_1.graphql(client_language_monaco_1.COMPLETION_MUTATION, { name: 'completionMutate' }), react_apollo_1.graphql(client_language_monaco_1.FORMATTING_MUTATION, { name: 'formattingMutate' }), react_apollo_1.graphql(client_language_monaco_1.REFERENCE_MUTATION, { name: 'referenceMutate' }), react_apollo_1.graphql(client_language_monaco_1.SYMBOL_MUTATION, { name: 'symbolMutate' }), react_apollo_1.graphql(client_language_monaco_1.DEFINITION_MUTATION, { name: 'definitionMutate' }), react_apollo_1.graphql(client_language_monaco_1.CLOSE_MUTATION, { name: 'closeMutate' }), react_apollo_1.graphql(client_language_monaco_1.HIGHLIGHT_MUTATION, { name: 'highlightMutate' }), react_apollo_1.graphql(client_language_monaco_1.LINK_MUTATION, { name: 'linkMutate' }), react_apollo_1.graphql(client_language_monaco_1.RENAME_EDITS_MUTATION, { name: 'renameEditsMutate' }))(react_apollo_1.graphql(client_language_monaco_1.INITIALIZE_QUERY, {
    skip: ({ language, enableLanguageService }) => !language || !enableLanguageService,
    options: ({ language, uri }) => ({ variables: { language, uri } }),
    props: ({ data: { loading, error, initializeEditor, refetch, fetchMore, subscribeToMore } }) => ({
        initializeEditor, error, refetch, loading, subscribeToMore,
    }),
})(MonacoEditor_1.default));


/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-language-monaco");

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const inversify_1 = __webpack_require__(2);
const modules_1 = __webpack_require__(17);
const utils_1 = __webpack_require__(21);
function noop() { }
const container = new inversify_1.Container();
let MonacoEditor = class MonacoEditor extends React.Component {
    constructor(props) {
        super(props);
        this.afterViewInit = () => {
            const context = this.props.context || window;
            if (context.monaco !== undefined) {
                this.initMonaco();
                return;
            }
        };
        this.assignRef = (component) => {
            this.containerElement = component;
        };
        this.containerElement = undefined;
        this.__current_value = props.value;
        this.subscription = null;
        this.registeredProviders = {};
    }
    componentDidMount() {
        this.afterViewInit();
    }
    componentWillReceiveProps(nextProps) {
        if (this.editor && nextProps.initializeEditor &&
            !nextProps.initializeEditor.error && nextProps.initializeEditor.uri === nextProps.uri &&
            (!this.props.initializeEditor || nextProps.initializeEditor.uri !== this.props.initializeEditor.uri)) {
            this.props.openDocumentMutate({
                variables: {
                    document: {
                        textDocument: {
                            uri: nextProps.uri,
                            languageId: nextProps.language,
                            version: 1,
                            text: nextProps.value,
                        },
                    },
                    language: nextProps.language,
                },
            })
                .then(() => {
                const context = this.props.context || window;
                if (!this.registeredProviders[this.props.language]) {
                    this.registeredProviders = Object.assign({}, this.registeredProviders, { [nextProps.language]: [] });
                }
                utils_1.registerProviders.apply(this);
            })
                .catch((error) => console.log('err', error));
        }
    }
    componentDidUpdate(prevProps) {
        const context = this.props.context || window;
        if (this.props.value !== this.__current_value) {
            this.__current_value = this.props.value;
            if (this.editor) {
                this.__prevent_trigger_change_event = true;
                this.editor.setValue(this.__current_value);
                this.__prevent_trigger_change_event = false;
            }
        }
        if (prevProps.language !== this.props.language) {
            context.monaco.editor.setModelLanguage(this.editor.getModel(), this.props.language);
        }
        if (prevProps.theme !== this.props.theme) {
            context.monaco.editor.setTheme(this.props.theme);
        }
    }
    componentWillUnmount() {
        if (this.props.initializeEditor && !this.props.initializeEditor.error) {
            this.props.closeMutate({
                variables: {
                    document: {
                        textDocument: {
                            uri: this.props.uri,
                        },
                    },
                    language: this.props.language,
                },
            });
        }
        for (let language of Object.keys(this.registeredProviders)) {
            this.registeredProviders[language].forEach(provider => {
                provider.dispose();
            });
        }
        this.destroyMonaco();
    }
    editorWillMount(monaco) {
        const { editorWillMount } = this.props;
        if (editorWillMount) {
            editorWillMount(monaco);
        }
    }
    editorDidMount(editor, monaco) {
        this.props.editorDidMount(editor, monaco);
        editor.onDidChangeModelContent((event) => {
            console.log('event', event);
            const value = editor.getValue();
            this.__current_value = value;
            if (!this.__prevent_trigger_change_event) {
                if (this.props.initializeEditor && !this.props.initializeEditor.error) {
                    this.props.changeDocumentMutate({
                        variables: {
                            document: {
                                textDocument: {
                                    uri: this.props.uri,
                                    version: event.versionId,
                                },
                                contentChanges: event.changes,
                            },
                            language: this.props.language,
                        },
                    })
                        .catch((error) => console.log('err', error));
                }
                this.props.onChange(value, event);
            }
        });
        modules_1.default.registerLanguages(monaco);
    }
    create(options, override) {
        const context = this.props.context || window;
        return this.editor = context.monaco.editor.create(this.containerElement, Object.assign({}, options, { fixedOverflowWidgets: true, scrollbar: {
                useShadows: false,
                verticalHasArrows: false,
                horizontalHasArrows: false,
                verticalScrollbarSize: 10,
                horizontalScrollbarSize: 10,
            } }), override);
    }
    initMonaco() {
        const value = this.props.value !== null ? this.props.value : this.props.defaultValue;
        const { language, theme, options } = this.props;
        const context = this.props.context || window;
        if (this.containerElement && typeof context.monaco !== 'undefined') {
            this.editorWillMount(context.monaco);
            this.editor = this.create(Object.assign({ value,
                language }, options));
            if (theme) {
                context.monaco.editor.setTheme(theme);
            }
            this.editorDidMount(this.editor, context.monaco);
        }
    }
    destroyMonaco() {
        if (typeof this.editor !== 'undefined') {
            this.editor.dispose();
        }
    }
    render() {
        const { width, height } = this.props;
        const fixedWidth = width.toString().indexOf('%') !== -1 ? width : `${width}px`;
        const fixedHeight = height.toString().indexOf('%') !== -1 ? height : `${height}px`;
        const style = {
            width: fixedWidth,
            height: fixedHeight,
        };
        return (React.createElement("div", { ref: this.assignRef, style: style, className: "react-monaco-editor-container" }));
    }
};
MonacoEditor.defaultProps = {
    width: '100%',
    height: '100%',
    value: null,
    defaultValue: '',
    language: 'plaintext',
    theme: null,
    options: {},
    editorDidMount: noop,
    editorWillMount: noop,
    onChange: noop,
    uri: '',
};
MonacoEditor = __decorate([
    inversify_1.injectable()
], MonacoEditor);
exports.default = MonacoEditor;


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const client_react_1 = __webpack_require__(18);
const browser_1 = __webpack_require__(19);
const browser_2 = __webpack_require__(20);
exports.default = new client_react_1.Feature(browser_1.default, browser_2.default);


/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = require("@common-stack/client-react");

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/typescript/lib/browser");

/***/ }),
/* 20 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/default-languages/lib/browser");

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(22));
__export(__webpack_require__(23));


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.register = (monaco, language) => {
    monaco.languages.registerHoverProvider(language, {
        provideHover: function (model, position) {
            return {
                range: new monaco.Range(1, 1, model.getLineCount(), model.getLineMaxColumn(model.getLineCount())),
                contents: [
                    '**SOURCE**',
                    { language: 'go', value: 'hello' },
                ],
            };
        },
    });
};


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const overallCapabilities_1 = __webpack_require__(24);
function registerProviders() {
    const { subscribeToMore } = this.props;
    const context = this.props.context || window;
    const { uri } = this.props;
    this.editor.setModel(monaco.editor.createModel(this.props.value, this.props.language, monaco.Uri.parse(uri)));
    const cpb = this.props.initializeEditor.capabilities;
    const providerExist = this.registeredProviders[this.props.language].length;
    if (cpb[overallCapabilities_1.default.hoverProvider] && !providerExist) {
        const hoverRes = context.monaco.languages.registerHoverProvider(this.props.language, {
            provideHover: (model, position) => {
                return this.props.hoverMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            position: {
                                line: position.lineNumber - 1,
                                character: position.column,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => {
                    return data.hover;
                })
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(hoverRes);
    }
    if (cpb[overallCapabilities_1.default.completionProvider] && !providerExist) {
        const completionRes = context.monaco.languages.registerCompletionItemProvider(this.props.language, {
            provideCompletionItems: (document, position, token) => {
                return this.props.completionMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            position: {
                                line: position.lineNumber - 1,
                                character: position.column - 1,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => {
                    console.log('data', data);
                    return data.completion;
                })
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(completionRes);
    }
    if (cpb[overallCapabilities_1.default.documentRangeFormattingProvider] && !providerExist) {
        const formattingRes = context.monaco.languages.registerDocumentRangeFormattingEditProvider(this.props.language, {
            provideDocumentRangeFormattingEdits: (model, options, token) => {
                return this.props.formattingMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            options: {
                                tabSize: options.tabSize,
                                insertSpaces: options.insertSpaces,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => data.formattingDocument.map(item => {
                    return {
                        text: item.newText,
                        range: {
                            startColumn: item.range.start.character,
                            startLineNumber: item.range.start.line + 1,
                            endColumn: item.range.end.character,
                            endLineNumber: item.range.end.line + 1,
                        },
                    };
                }))
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(formattingRes);
    }
    if (cpb[overallCapabilities_1.default.documentSymbolProvider] && !providerExist) {
        const symbolRes = context.monaco.languages.registerDocumentSymbolProvider(this.props.language, {
            provideDocumentSymbols: (document, token) => {
                return this.props.symbolMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => data.documentSymbol.map(item => {
                    return Object.assign({}, item, { location: Object.assign({}, item.location, { range: {
                                startColumn: item.range.start.character,
                                startLineNumber: item.range.start.line + 1,
                                endColumn: item.range.end.character,
                                endLineNumber: item.range.end.line + 1,
                            } }) });
                }))
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(symbolRes);
    }
    if (cpb[overallCapabilities_1.default.referencesProvider] && !providerExist) {
        const referenceRes = context.monaco.languages.registerReferenceProvider(this.props.language, {
            provideReferences: async (model, position, context, token) => {
                return await this.props.referenceMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            position: {
                                line: position.lineNumber - 1,
                                character: position.column - 1,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => {
                    return data.references.map(item => {
                        return {
                            uri: monaco.Uri.parse(this.uri),
                            range: {
                                startColumn: item.range.start.character + 1,
                                startLineNumber: item.range.start.line + 1,
                                endColumn: item.range.end.character + 1,
                                endLineNumber: item.range.end.line + 1,
                            },
                        };
                    });
                })
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(referenceRes);
    }
    if (cpb[overallCapabilities_1.default.definitionProvider] && !providerExist) {
        const definitionRes = context.monaco.languages.registerDefinitionProvider(this.props.language, {
            provideDefinition: (model, position, token) => {
                return this.props.definitionMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            position: {
                                line: position.lineNumber - 1,
                                character: position.column - 1,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data: { definition } }) => {
                    console.log('definition', definition);
                    return {
                        uri: monaco.Uri.parse(definition.uri),
                        range: {
                            startColumn: definition.range.start.character,
                            startLineNumber: definition.range.start.line + 1,
                            endColumn: definition.range.end.character,
                            endLineNumber: definition.range.end.line + 1,
                        },
                    };
                })
                    .catch((error) => console.log('err', error));
            },
        });
        this.registeredProviders[this.props.language].push(definitionRes);
    }
    if (cpb[overallCapabilities_1.default.documentHighlightProvider] && !providerExist) {
        const highLightRes = context.monaco.languages.registerDocumentHighlightProvider(this.props.language, {
            provideDocumentHighlights: (model, position, token) => {
                return this.props.highlightMutate({
                    variables: {
                        params: {
                            position: {
                                line: position.lineNumber - 1,
                                character: position.column - 1,
                            },
                            textDocument: {
                                uri,
                            },
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data }) => {
                    console.log('data', data);
                    return data.documentHighlight;
                });
            },
        });
        this.registeredProviders[this.props.language].push(highLightRes);
    }
    if (cpb[overallCapabilities_1.default.renameProvider] && !providerExist) {
        const renameRes = context.monaco.languages.registerRenameProvider(this.props.language, {
            provideRenameEdits: (model, position, newName, token) => {
                return this.props.renameEditsMutate({
                    variables: {
                        params: {
                            textDocument: { uri },
                            position: {
                                line: position.lineNumber,
                                character: position.column,
                            },
                            newName,
                        },
                        language: this.props.language,
                    },
                })
                    .then(({ data: { renameEdits } }) => {
                    console.log('renameEdits', renameEdits);
                    return renameEdits;
                });
            },
        });
        this.registeredProviders[this.props.language].push(renameRes);
    }
}
exports.registerProviders = registerProviders;


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    completionProvider: 'completionProvider',
    hoverProvider: 'hoverProvider',
    documentHighlightProvider: 'documentHighlightProvider',
    documentRangeFormattingProvider: 'documentRangeFormattingProvider',
    documentLinkProvider: 'documentLinkProvider',
    documentSymbolProvider: 'documentSymbolProvider',
    definitionProvider: 'definitionProvider',
    signatureHelpProvider: 'signatureHelpProvider',
    referencesProvider: 'referencesProvider',
    colorProvider: 'colorProvider',
    renameProvider: 'renameProvider',
};


/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map